import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_DisassociateMemberFromGroupCommand, se_DisassociateMemberFromGroupCommand } from "../protocols/Aws_json1_1";
export { $Command };
export class DisassociateMemberFromGroupCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("WorkMailService", "DisassociateMemberFromGroup", {})
    .n("WorkMailClient", "DisassociateMemberFromGroupCommand")
    .f(void 0, void 0)
    .ser(se_DisassociateMemberFromGroupCommand)
    .de(de_DisassociateMemberFromGroupCommand)
    .build() {
}
