import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_UpdatePrimaryEmailAddressCommand, se_UpdatePrimaryEmailAddressCommand } from "../protocols/Aws_json1_1";
export { $Command };
export class UpdatePrimaryEmailAddressCommand extends $Command
    .classBuilder()
    .ep({
    ...commonParams,
})
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("WorkMailService", "UpdatePrimaryEmailAddress", {})
    .n("WorkMailClient", "UpdatePrimaryEmailAddressCommand")
    .f(void 0, void 0)
    .ser(se_UpdatePrimaryEmailAddressCommand)
    .de(de_UpdatePrimaryEmailAddressCommand)
    .build() {
}
