import { HttpHandlerOptions as __HttpHandlerOptions } from "@smithy/types";
import {
  AssociateDelegateToResourceCommandInput,
  AssociateDelegateToResourceCommandOutput,
} from "./commands/AssociateDelegateToResourceCommand";
import {
  AssociateMemberToGroupCommandInput,
  AssociateMemberToGroupCommandOutput,
} from "./commands/AssociateMemberToGroupCommand";
import {
  AssumeImpersonationRoleCommandInput,
  AssumeImpersonationRoleCommandOutput,
} from "./commands/AssumeImpersonationRoleCommand";
import {
  CancelMailboxExportJobCommandInput,
  CancelMailboxExportJobCommandOutput,
} from "./commands/CancelMailboxExportJobCommand";
import {
  CreateAliasCommandInput,
  CreateAliasCommandOutput,
} from "./commands/CreateAliasCommand";
import {
  CreateAvailabilityConfigurationCommandInput,
  CreateAvailabilityConfigurationCommandOutput,
} from "./commands/CreateAvailabilityConfigurationCommand";
import {
  CreateGroupCommandInput,
  CreateGroupCommandOutput,
} from "./commands/CreateGroupCommand";
import {
  CreateImpersonationRoleCommandInput,
  CreateImpersonationRoleCommandOutput,
} from "./commands/CreateImpersonationRoleCommand";
import {
  CreateMobileDeviceAccessRuleCommandInput,
  CreateMobileDeviceAccessRuleCommandOutput,
} from "./commands/CreateMobileDeviceAccessRuleCommand";
import {
  CreateOrganizationCommandInput,
  CreateOrganizationCommandOutput,
} from "./commands/CreateOrganizationCommand";
import {
  CreateResourceCommandInput,
  CreateResourceCommandOutput,
} from "./commands/CreateResourceCommand";
import {
  CreateUserCommandInput,
  CreateUserCommandOutput,
} from "./commands/CreateUserCommand";
import {
  DeleteAccessControlRuleCommandInput,
  DeleteAccessControlRuleCommandOutput,
} from "./commands/DeleteAccessControlRuleCommand";
import {
  DeleteAliasCommandInput,
  DeleteAliasCommandOutput,
} from "./commands/DeleteAliasCommand";
import {
  DeleteAvailabilityConfigurationCommandInput,
  DeleteAvailabilityConfigurationCommandOutput,
} from "./commands/DeleteAvailabilityConfigurationCommand";
import {
  DeleteEmailMonitoringConfigurationCommandInput,
  DeleteEmailMonitoringConfigurationCommandOutput,
} from "./commands/DeleteEmailMonitoringConfigurationCommand";
import {
  DeleteGroupCommandInput,
  DeleteGroupCommandOutput,
} from "./commands/DeleteGroupCommand";
import {
  DeleteImpersonationRoleCommandInput,
  DeleteImpersonationRoleCommandOutput,
} from "./commands/DeleteImpersonationRoleCommand";
import {
  DeleteMailboxPermissionsCommandInput,
  DeleteMailboxPermissionsCommandOutput,
} from "./commands/DeleteMailboxPermissionsCommand";
import {
  DeleteMobileDeviceAccessOverrideCommandInput,
  DeleteMobileDeviceAccessOverrideCommandOutput,
} from "./commands/DeleteMobileDeviceAccessOverrideCommand";
import {
  DeleteMobileDeviceAccessRuleCommandInput,
  DeleteMobileDeviceAccessRuleCommandOutput,
} from "./commands/DeleteMobileDeviceAccessRuleCommand";
import {
  DeleteOrganizationCommandInput,
  DeleteOrganizationCommandOutput,
} from "./commands/DeleteOrganizationCommand";
import {
  DeleteResourceCommandInput,
  DeleteResourceCommandOutput,
} from "./commands/DeleteResourceCommand";
import {
  DeleteRetentionPolicyCommandInput,
  DeleteRetentionPolicyCommandOutput,
} from "./commands/DeleteRetentionPolicyCommand";
import {
  DeleteUserCommandInput,
  DeleteUserCommandOutput,
} from "./commands/DeleteUserCommand";
import {
  DeregisterFromWorkMailCommandInput,
  DeregisterFromWorkMailCommandOutput,
} from "./commands/DeregisterFromWorkMailCommand";
import {
  DeregisterMailDomainCommandInput,
  DeregisterMailDomainCommandOutput,
} from "./commands/DeregisterMailDomainCommand";
import {
  DescribeEmailMonitoringConfigurationCommandInput,
  DescribeEmailMonitoringConfigurationCommandOutput,
} from "./commands/DescribeEmailMonitoringConfigurationCommand";
import {
  DescribeEntityCommandInput,
  DescribeEntityCommandOutput,
} from "./commands/DescribeEntityCommand";
import {
  DescribeGroupCommandInput,
  DescribeGroupCommandOutput,
} from "./commands/DescribeGroupCommand";
import {
  DescribeInboundDmarcSettingsCommandInput,
  DescribeInboundDmarcSettingsCommandOutput,
} from "./commands/DescribeInboundDmarcSettingsCommand";
import {
  DescribeMailboxExportJobCommandInput,
  DescribeMailboxExportJobCommandOutput,
} from "./commands/DescribeMailboxExportJobCommand";
import {
  DescribeOrganizationCommandInput,
  DescribeOrganizationCommandOutput,
} from "./commands/DescribeOrganizationCommand";
import {
  DescribeResourceCommandInput,
  DescribeResourceCommandOutput,
} from "./commands/DescribeResourceCommand";
import {
  DescribeUserCommandInput,
  DescribeUserCommandOutput,
} from "./commands/DescribeUserCommand";
import {
  DisassociateDelegateFromResourceCommandInput,
  DisassociateDelegateFromResourceCommandOutput,
} from "./commands/DisassociateDelegateFromResourceCommand";
import {
  DisassociateMemberFromGroupCommandInput,
  DisassociateMemberFromGroupCommandOutput,
} from "./commands/DisassociateMemberFromGroupCommand";
import {
  GetAccessControlEffectCommandInput,
  GetAccessControlEffectCommandOutput,
} from "./commands/GetAccessControlEffectCommand";
import {
  GetDefaultRetentionPolicyCommandInput,
  GetDefaultRetentionPolicyCommandOutput,
} from "./commands/GetDefaultRetentionPolicyCommand";
import {
  GetImpersonationRoleCommandInput,
  GetImpersonationRoleCommandOutput,
} from "./commands/GetImpersonationRoleCommand";
import {
  GetImpersonationRoleEffectCommandInput,
  GetImpersonationRoleEffectCommandOutput,
} from "./commands/GetImpersonationRoleEffectCommand";
import {
  GetMailboxDetailsCommandInput,
  GetMailboxDetailsCommandOutput,
} from "./commands/GetMailboxDetailsCommand";
import {
  GetMailDomainCommandInput,
  GetMailDomainCommandOutput,
} from "./commands/GetMailDomainCommand";
import {
  GetMobileDeviceAccessEffectCommandInput,
  GetMobileDeviceAccessEffectCommandOutput,
} from "./commands/GetMobileDeviceAccessEffectCommand";
import {
  GetMobileDeviceAccessOverrideCommandInput,
  GetMobileDeviceAccessOverrideCommandOutput,
} from "./commands/GetMobileDeviceAccessOverrideCommand";
import {
  ListAccessControlRulesCommandInput,
  ListAccessControlRulesCommandOutput,
} from "./commands/ListAccessControlRulesCommand";
import {
  ListAliasesCommandInput,
  ListAliasesCommandOutput,
} from "./commands/ListAliasesCommand";
import {
  ListAvailabilityConfigurationsCommandInput,
  ListAvailabilityConfigurationsCommandOutput,
} from "./commands/ListAvailabilityConfigurationsCommand";
import {
  ListGroupMembersCommandInput,
  ListGroupMembersCommandOutput,
} from "./commands/ListGroupMembersCommand";
import {
  ListGroupsCommandInput,
  ListGroupsCommandOutput,
} from "./commands/ListGroupsCommand";
import {
  ListGroupsForEntityCommandInput,
  ListGroupsForEntityCommandOutput,
} from "./commands/ListGroupsForEntityCommand";
import {
  ListImpersonationRolesCommandInput,
  ListImpersonationRolesCommandOutput,
} from "./commands/ListImpersonationRolesCommand";
import {
  ListMailboxExportJobsCommandInput,
  ListMailboxExportJobsCommandOutput,
} from "./commands/ListMailboxExportJobsCommand";
import {
  ListMailboxPermissionsCommandInput,
  ListMailboxPermissionsCommandOutput,
} from "./commands/ListMailboxPermissionsCommand";
import {
  ListMailDomainsCommandInput,
  ListMailDomainsCommandOutput,
} from "./commands/ListMailDomainsCommand";
import {
  ListMobileDeviceAccessOverridesCommandInput,
  ListMobileDeviceAccessOverridesCommandOutput,
} from "./commands/ListMobileDeviceAccessOverridesCommand";
import {
  ListMobileDeviceAccessRulesCommandInput,
  ListMobileDeviceAccessRulesCommandOutput,
} from "./commands/ListMobileDeviceAccessRulesCommand";
import {
  ListOrganizationsCommandInput,
  ListOrganizationsCommandOutput,
} from "./commands/ListOrganizationsCommand";
import {
  ListResourceDelegatesCommandInput,
  ListResourceDelegatesCommandOutput,
} from "./commands/ListResourceDelegatesCommand";
import {
  ListResourcesCommandInput,
  ListResourcesCommandOutput,
} from "./commands/ListResourcesCommand";
import {
  ListTagsForResourceCommandInput,
  ListTagsForResourceCommandOutput,
} from "./commands/ListTagsForResourceCommand";
import {
  ListUsersCommandInput,
  ListUsersCommandOutput,
} from "./commands/ListUsersCommand";
import {
  PutAccessControlRuleCommandInput,
  PutAccessControlRuleCommandOutput,
} from "./commands/PutAccessControlRuleCommand";
import {
  PutEmailMonitoringConfigurationCommandInput,
  PutEmailMonitoringConfigurationCommandOutput,
} from "./commands/PutEmailMonitoringConfigurationCommand";
import {
  PutInboundDmarcSettingsCommandInput,
  PutInboundDmarcSettingsCommandOutput,
} from "./commands/PutInboundDmarcSettingsCommand";
import {
  PutMailboxPermissionsCommandInput,
  PutMailboxPermissionsCommandOutput,
} from "./commands/PutMailboxPermissionsCommand";
import {
  PutMobileDeviceAccessOverrideCommandInput,
  PutMobileDeviceAccessOverrideCommandOutput,
} from "./commands/PutMobileDeviceAccessOverrideCommand";
import {
  PutRetentionPolicyCommandInput,
  PutRetentionPolicyCommandOutput,
} from "./commands/PutRetentionPolicyCommand";
import {
  RegisterMailDomainCommandInput,
  RegisterMailDomainCommandOutput,
} from "./commands/RegisterMailDomainCommand";
import {
  RegisterToWorkMailCommandInput,
  RegisterToWorkMailCommandOutput,
} from "./commands/RegisterToWorkMailCommand";
import {
  ResetPasswordCommandInput,
  ResetPasswordCommandOutput,
} from "./commands/ResetPasswordCommand";
import {
  StartMailboxExportJobCommandInput,
  StartMailboxExportJobCommandOutput,
} from "./commands/StartMailboxExportJobCommand";
import {
  TagResourceCommandInput,
  TagResourceCommandOutput,
} from "./commands/TagResourceCommand";
import {
  TestAvailabilityConfigurationCommandInput,
  TestAvailabilityConfigurationCommandOutput,
} from "./commands/TestAvailabilityConfigurationCommand";
import {
  UntagResourceCommandInput,
  UntagResourceCommandOutput,
} from "./commands/UntagResourceCommand";
import {
  UpdateAvailabilityConfigurationCommandInput,
  UpdateAvailabilityConfigurationCommandOutput,
} from "./commands/UpdateAvailabilityConfigurationCommand";
import {
  UpdateDefaultMailDomainCommandInput,
  UpdateDefaultMailDomainCommandOutput,
} from "./commands/UpdateDefaultMailDomainCommand";
import {
  UpdateGroupCommandInput,
  UpdateGroupCommandOutput,
} from "./commands/UpdateGroupCommand";
import {
  UpdateImpersonationRoleCommandInput,
  UpdateImpersonationRoleCommandOutput,
} from "./commands/UpdateImpersonationRoleCommand";
import {
  UpdateMailboxQuotaCommandInput,
  UpdateMailboxQuotaCommandOutput,
} from "./commands/UpdateMailboxQuotaCommand";
import {
  UpdateMobileDeviceAccessRuleCommandInput,
  UpdateMobileDeviceAccessRuleCommandOutput,
} from "./commands/UpdateMobileDeviceAccessRuleCommand";
import {
  UpdatePrimaryEmailAddressCommandInput,
  UpdatePrimaryEmailAddressCommandOutput,
} from "./commands/UpdatePrimaryEmailAddressCommand";
import {
  UpdateResourceCommandInput,
  UpdateResourceCommandOutput,
} from "./commands/UpdateResourceCommand";
import {
  UpdateUserCommandInput,
  UpdateUserCommandOutput,
} from "./commands/UpdateUserCommand";
import { WorkMailClient } from "./WorkMailClient";
export interface WorkMail {
  associateDelegateToResource(
    args: AssociateDelegateToResourceCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<AssociateDelegateToResourceCommandOutput>;
  associateDelegateToResource(
    args: AssociateDelegateToResourceCommandInput,
    cb: (err: any, data?: AssociateDelegateToResourceCommandOutput) => void
  ): void;
  associateDelegateToResource(
    args: AssociateDelegateToResourceCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: AssociateDelegateToResourceCommandOutput) => void
  ): void;
  associateMemberToGroup(
    args: AssociateMemberToGroupCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<AssociateMemberToGroupCommandOutput>;
  associateMemberToGroup(
    args: AssociateMemberToGroupCommandInput,
    cb: (err: any, data?: AssociateMemberToGroupCommandOutput) => void
  ): void;
  associateMemberToGroup(
    args: AssociateMemberToGroupCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: AssociateMemberToGroupCommandOutput) => void
  ): void;
  assumeImpersonationRole(
    args: AssumeImpersonationRoleCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<AssumeImpersonationRoleCommandOutput>;
  assumeImpersonationRole(
    args: AssumeImpersonationRoleCommandInput,
    cb: (err: any, data?: AssumeImpersonationRoleCommandOutput) => void
  ): void;
  assumeImpersonationRole(
    args: AssumeImpersonationRoleCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: AssumeImpersonationRoleCommandOutput) => void
  ): void;
  cancelMailboxExportJob(
    args: CancelMailboxExportJobCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<CancelMailboxExportJobCommandOutput>;
  cancelMailboxExportJob(
    args: CancelMailboxExportJobCommandInput,
    cb: (err: any, data?: CancelMailboxExportJobCommandOutput) => void
  ): void;
  cancelMailboxExportJob(
    args: CancelMailboxExportJobCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: CancelMailboxExportJobCommandOutput) => void
  ): void;
  createAlias(
    args: CreateAliasCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<CreateAliasCommandOutput>;
  createAlias(
    args: CreateAliasCommandInput,
    cb: (err: any, data?: CreateAliasCommandOutput) => void
  ): void;
  createAlias(
    args: CreateAliasCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: CreateAliasCommandOutput) => void
  ): void;
  createAvailabilityConfiguration(
    args: CreateAvailabilityConfigurationCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<CreateAvailabilityConfigurationCommandOutput>;
  createAvailabilityConfiguration(
    args: CreateAvailabilityConfigurationCommandInput,
    cb: (err: any, data?: CreateAvailabilityConfigurationCommandOutput) => void
  ): void;
  createAvailabilityConfiguration(
    args: CreateAvailabilityConfigurationCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: CreateAvailabilityConfigurationCommandOutput) => void
  ): void;
  createGroup(
    args: CreateGroupCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<CreateGroupCommandOutput>;
  createGroup(
    args: CreateGroupCommandInput,
    cb: (err: any, data?: CreateGroupCommandOutput) => void
  ): void;
  createGroup(
    args: CreateGroupCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: CreateGroupCommandOutput) => void
  ): void;
  createImpersonationRole(
    args: CreateImpersonationRoleCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<CreateImpersonationRoleCommandOutput>;
  createImpersonationRole(
    args: CreateImpersonationRoleCommandInput,
    cb: (err: any, data?: CreateImpersonationRoleCommandOutput) => void
  ): void;
  createImpersonationRole(
    args: CreateImpersonationRoleCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: CreateImpersonationRoleCommandOutput) => void
  ): void;
  createMobileDeviceAccessRule(
    args: CreateMobileDeviceAccessRuleCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<CreateMobileDeviceAccessRuleCommandOutput>;
  createMobileDeviceAccessRule(
    args: CreateMobileDeviceAccessRuleCommandInput,
    cb: (err: any, data?: CreateMobileDeviceAccessRuleCommandOutput) => void
  ): void;
  createMobileDeviceAccessRule(
    args: CreateMobileDeviceAccessRuleCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: CreateMobileDeviceAccessRuleCommandOutput) => void
  ): void;
  createOrganization(
    args: CreateOrganizationCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<CreateOrganizationCommandOutput>;
  createOrganization(
    args: CreateOrganizationCommandInput,
    cb: (err: any, data?: CreateOrganizationCommandOutput) => void
  ): void;
  createOrganization(
    args: CreateOrganizationCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: CreateOrganizationCommandOutput) => void
  ): void;
  createResource(
    args: CreateResourceCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<CreateResourceCommandOutput>;
  createResource(
    args: CreateResourceCommandInput,
    cb: (err: any, data?: CreateResourceCommandOutput) => void
  ): void;
  createResource(
    args: CreateResourceCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: CreateResourceCommandOutput) => void
  ): void;
  createUser(
    args: CreateUserCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<CreateUserCommandOutput>;
  createUser(
    args: CreateUserCommandInput,
    cb: (err: any, data?: CreateUserCommandOutput) => void
  ): void;
  createUser(
    args: CreateUserCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: CreateUserCommandOutput) => void
  ): void;
  deleteAccessControlRule(
    args: DeleteAccessControlRuleCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DeleteAccessControlRuleCommandOutput>;
  deleteAccessControlRule(
    args: DeleteAccessControlRuleCommandInput,
    cb: (err: any, data?: DeleteAccessControlRuleCommandOutput) => void
  ): void;
  deleteAccessControlRule(
    args: DeleteAccessControlRuleCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DeleteAccessControlRuleCommandOutput) => void
  ): void;
  deleteAlias(
    args: DeleteAliasCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DeleteAliasCommandOutput>;
  deleteAlias(
    args: DeleteAliasCommandInput,
    cb: (err: any, data?: DeleteAliasCommandOutput) => void
  ): void;
  deleteAlias(
    args: DeleteAliasCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DeleteAliasCommandOutput) => void
  ): void;
  deleteAvailabilityConfiguration(
    args: DeleteAvailabilityConfigurationCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DeleteAvailabilityConfigurationCommandOutput>;
  deleteAvailabilityConfiguration(
    args: DeleteAvailabilityConfigurationCommandInput,
    cb: (err: any, data?: DeleteAvailabilityConfigurationCommandOutput) => void
  ): void;
  deleteAvailabilityConfiguration(
    args: DeleteAvailabilityConfigurationCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DeleteAvailabilityConfigurationCommandOutput) => void
  ): void;
  deleteEmailMonitoringConfiguration(
    args: DeleteEmailMonitoringConfigurationCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DeleteEmailMonitoringConfigurationCommandOutput>;
  deleteEmailMonitoringConfiguration(
    args: DeleteEmailMonitoringConfigurationCommandInput,
    cb: (
      err: any,
      data?: DeleteEmailMonitoringConfigurationCommandOutput
    ) => void
  ): void;
  deleteEmailMonitoringConfiguration(
    args: DeleteEmailMonitoringConfigurationCommandInput,
    options: __HttpHandlerOptions,
    cb: (
      err: any,
      data?: DeleteEmailMonitoringConfigurationCommandOutput
    ) => void
  ): void;
  deleteGroup(
    args: DeleteGroupCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DeleteGroupCommandOutput>;
  deleteGroup(
    args: DeleteGroupCommandInput,
    cb: (err: any, data?: DeleteGroupCommandOutput) => void
  ): void;
  deleteGroup(
    args: DeleteGroupCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DeleteGroupCommandOutput) => void
  ): void;
  deleteImpersonationRole(
    args: DeleteImpersonationRoleCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DeleteImpersonationRoleCommandOutput>;
  deleteImpersonationRole(
    args: DeleteImpersonationRoleCommandInput,
    cb: (err: any, data?: DeleteImpersonationRoleCommandOutput) => void
  ): void;
  deleteImpersonationRole(
    args: DeleteImpersonationRoleCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DeleteImpersonationRoleCommandOutput) => void
  ): void;
  deleteMailboxPermissions(
    args: DeleteMailboxPermissionsCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DeleteMailboxPermissionsCommandOutput>;
  deleteMailboxPermissions(
    args: DeleteMailboxPermissionsCommandInput,
    cb: (err: any, data?: DeleteMailboxPermissionsCommandOutput) => void
  ): void;
  deleteMailboxPermissions(
    args: DeleteMailboxPermissionsCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DeleteMailboxPermissionsCommandOutput) => void
  ): void;
  deleteMobileDeviceAccessOverride(
    args: DeleteMobileDeviceAccessOverrideCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DeleteMobileDeviceAccessOverrideCommandOutput>;
  deleteMobileDeviceAccessOverride(
    args: DeleteMobileDeviceAccessOverrideCommandInput,
    cb: (err: any, data?: DeleteMobileDeviceAccessOverrideCommandOutput) => void
  ): void;
  deleteMobileDeviceAccessOverride(
    args: DeleteMobileDeviceAccessOverrideCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DeleteMobileDeviceAccessOverrideCommandOutput) => void
  ): void;
  deleteMobileDeviceAccessRule(
    args: DeleteMobileDeviceAccessRuleCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DeleteMobileDeviceAccessRuleCommandOutput>;
  deleteMobileDeviceAccessRule(
    args: DeleteMobileDeviceAccessRuleCommandInput,
    cb: (err: any, data?: DeleteMobileDeviceAccessRuleCommandOutput) => void
  ): void;
  deleteMobileDeviceAccessRule(
    args: DeleteMobileDeviceAccessRuleCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DeleteMobileDeviceAccessRuleCommandOutput) => void
  ): void;
  deleteOrganization(
    args: DeleteOrganizationCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DeleteOrganizationCommandOutput>;
  deleteOrganization(
    args: DeleteOrganizationCommandInput,
    cb: (err: any, data?: DeleteOrganizationCommandOutput) => void
  ): void;
  deleteOrganization(
    args: DeleteOrganizationCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DeleteOrganizationCommandOutput) => void
  ): void;
  deleteResource(
    args: DeleteResourceCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DeleteResourceCommandOutput>;
  deleteResource(
    args: DeleteResourceCommandInput,
    cb: (err: any, data?: DeleteResourceCommandOutput) => void
  ): void;
  deleteResource(
    args: DeleteResourceCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DeleteResourceCommandOutput) => void
  ): void;
  deleteRetentionPolicy(
    args: DeleteRetentionPolicyCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DeleteRetentionPolicyCommandOutput>;
  deleteRetentionPolicy(
    args: DeleteRetentionPolicyCommandInput,
    cb: (err: any, data?: DeleteRetentionPolicyCommandOutput) => void
  ): void;
  deleteRetentionPolicy(
    args: DeleteRetentionPolicyCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DeleteRetentionPolicyCommandOutput) => void
  ): void;
  deleteUser(
    args: DeleteUserCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DeleteUserCommandOutput>;
  deleteUser(
    args: DeleteUserCommandInput,
    cb: (err: any, data?: DeleteUserCommandOutput) => void
  ): void;
  deleteUser(
    args: DeleteUserCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DeleteUserCommandOutput) => void
  ): void;
  deregisterFromWorkMail(
    args: DeregisterFromWorkMailCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DeregisterFromWorkMailCommandOutput>;
  deregisterFromWorkMail(
    args: DeregisterFromWorkMailCommandInput,
    cb: (err: any, data?: DeregisterFromWorkMailCommandOutput) => void
  ): void;
  deregisterFromWorkMail(
    args: DeregisterFromWorkMailCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DeregisterFromWorkMailCommandOutput) => void
  ): void;
  deregisterMailDomain(
    args: DeregisterMailDomainCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DeregisterMailDomainCommandOutput>;
  deregisterMailDomain(
    args: DeregisterMailDomainCommandInput,
    cb: (err: any, data?: DeregisterMailDomainCommandOutput) => void
  ): void;
  deregisterMailDomain(
    args: DeregisterMailDomainCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DeregisterMailDomainCommandOutput) => void
  ): void;
  describeEmailMonitoringConfiguration(
    args: DescribeEmailMonitoringConfigurationCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DescribeEmailMonitoringConfigurationCommandOutput>;
  describeEmailMonitoringConfiguration(
    args: DescribeEmailMonitoringConfigurationCommandInput,
    cb: (
      err: any,
      data?: DescribeEmailMonitoringConfigurationCommandOutput
    ) => void
  ): void;
  describeEmailMonitoringConfiguration(
    args: DescribeEmailMonitoringConfigurationCommandInput,
    options: __HttpHandlerOptions,
    cb: (
      err: any,
      data?: DescribeEmailMonitoringConfigurationCommandOutput
    ) => void
  ): void;
  describeEntity(
    args: DescribeEntityCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DescribeEntityCommandOutput>;
  describeEntity(
    args: DescribeEntityCommandInput,
    cb: (err: any, data?: DescribeEntityCommandOutput) => void
  ): void;
  describeEntity(
    args: DescribeEntityCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DescribeEntityCommandOutput) => void
  ): void;
  describeGroup(
    args: DescribeGroupCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DescribeGroupCommandOutput>;
  describeGroup(
    args: DescribeGroupCommandInput,
    cb: (err: any, data?: DescribeGroupCommandOutput) => void
  ): void;
  describeGroup(
    args: DescribeGroupCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DescribeGroupCommandOutput) => void
  ): void;
  describeInboundDmarcSettings(
    args: DescribeInboundDmarcSettingsCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DescribeInboundDmarcSettingsCommandOutput>;
  describeInboundDmarcSettings(
    args: DescribeInboundDmarcSettingsCommandInput,
    cb: (err: any, data?: DescribeInboundDmarcSettingsCommandOutput) => void
  ): void;
  describeInboundDmarcSettings(
    args: DescribeInboundDmarcSettingsCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DescribeInboundDmarcSettingsCommandOutput) => void
  ): void;
  describeMailboxExportJob(
    args: DescribeMailboxExportJobCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DescribeMailboxExportJobCommandOutput>;
  describeMailboxExportJob(
    args: DescribeMailboxExportJobCommandInput,
    cb: (err: any, data?: DescribeMailboxExportJobCommandOutput) => void
  ): void;
  describeMailboxExportJob(
    args: DescribeMailboxExportJobCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DescribeMailboxExportJobCommandOutput) => void
  ): void;
  describeOrganization(
    args: DescribeOrganizationCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DescribeOrganizationCommandOutput>;
  describeOrganization(
    args: DescribeOrganizationCommandInput,
    cb: (err: any, data?: DescribeOrganizationCommandOutput) => void
  ): void;
  describeOrganization(
    args: DescribeOrganizationCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DescribeOrganizationCommandOutput) => void
  ): void;
  describeResource(
    args: DescribeResourceCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DescribeResourceCommandOutput>;
  describeResource(
    args: DescribeResourceCommandInput,
    cb: (err: any, data?: DescribeResourceCommandOutput) => void
  ): void;
  describeResource(
    args: DescribeResourceCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DescribeResourceCommandOutput) => void
  ): void;
  describeUser(
    args: DescribeUserCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DescribeUserCommandOutput>;
  describeUser(
    args: DescribeUserCommandInput,
    cb: (err: any, data?: DescribeUserCommandOutput) => void
  ): void;
  describeUser(
    args: DescribeUserCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DescribeUserCommandOutput) => void
  ): void;
  disassociateDelegateFromResource(
    args: DisassociateDelegateFromResourceCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DisassociateDelegateFromResourceCommandOutput>;
  disassociateDelegateFromResource(
    args: DisassociateDelegateFromResourceCommandInput,
    cb: (err: any, data?: DisassociateDelegateFromResourceCommandOutput) => void
  ): void;
  disassociateDelegateFromResource(
    args: DisassociateDelegateFromResourceCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DisassociateDelegateFromResourceCommandOutput) => void
  ): void;
  disassociateMemberFromGroup(
    args: DisassociateMemberFromGroupCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<DisassociateMemberFromGroupCommandOutput>;
  disassociateMemberFromGroup(
    args: DisassociateMemberFromGroupCommandInput,
    cb: (err: any, data?: DisassociateMemberFromGroupCommandOutput) => void
  ): void;
  disassociateMemberFromGroup(
    args: DisassociateMemberFromGroupCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: DisassociateMemberFromGroupCommandOutput) => void
  ): void;
  getAccessControlEffect(
    args: GetAccessControlEffectCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<GetAccessControlEffectCommandOutput>;
  getAccessControlEffect(
    args: GetAccessControlEffectCommandInput,
    cb: (err: any, data?: GetAccessControlEffectCommandOutput) => void
  ): void;
  getAccessControlEffect(
    args: GetAccessControlEffectCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: GetAccessControlEffectCommandOutput) => void
  ): void;
  getDefaultRetentionPolicy(
    args: GetDefaultRetentionPolicyCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<GetDefaultRetentionPolicyCommandOutput>;
  getDefaultRetentionPolicy(
    args: GetDefaultRetentionPolicyCommandInput,
    cb: (err: any, data?: GetDefaultRetentionPolicyCommandOutput) => void
  ): void;
  getDefaultRetentionPolicy(
    args: GetDefaultRetentionPolicyCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: GetDefaultRetentionPolicyCommandOutput) => void
  ): void;
  getImpersonationRole(
    args: GetImpersonationRoleCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<GetImpersonationRoleCommandOutput>;
  getImpersonationRole(
    args: GetImpersonationRoleCommandInput,
    cb: (err: any, data?: GetImpersonationRoleCommandOutput) => void
  ): void;
  getImpersonationRole(
    args: GetImpersonationRoleCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: GetImpersonationRoleCommandOutput) => void
  ): void;
  getImpersonationRoleEffect(
    args: GetImpersonationRoleEffectCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<GetImpersonationRoleEffectCommandOutput>;
  getImpersonationRoleEffect(
    args: GetImpersonationRoleEffectCommandInput,
    cb: (err: any, data?: GetImpersonationRoleEffectCommandOutput) => void
  ): void;
  getImpersonationRoleEffect(
    args: GetImpersonationRoleEffectCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: GetImpersonationRoleEffectCommandOutput) => void
  ): void;
  getMailboxDetails(
    args: GetMailboxDetailsCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<GetMailboxDetailsCommandOutput>;
  getMailboxDetails(
    args: GetMailboxDetailsCommandInput,
    cb: (err: any, data?: GetMailboxDetailsCommandOutput) => void
  ): void;
  getMailboxDetails(
    args: GetMailboxDetailsCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: GetMailboxDetailsCommandOutput) => void
  ): void;
  getMailDomain(
    args: GetMailDomainCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<GetMailDomainCommandOutput>;
  getMailDomain(
    args: GetMailDomainCommandInput,
    cb: (err: any, data?: GetMailDomainCommandOutput) => void
  ): void;
  getMailDomain(
    args: GetMailDomainCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: GetMailDomainCommandOutput) => void
  ): void;
  getMobileDeviceAccessEffect(
    args: GetMobileDeviceAccessEffectCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<GetMobileDeviceAccessEffectCommandOutput>;
  getMobileDeviceAccessEffect(
    args: GetMobileDeviceAccessEffectCommandInput,
    cb: (err: any, data?: GetMobileDeviceAccessEffectCommandOutput) => void
  ): void;
  getMobileDeviceAccessEffect(
    args: GetMobileDeviceAccessEffectCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: GetMobileDeviceAccessEffectCommandOutput) => void
  ): void;
  getMobileDeviceAccessOverride(
    args: GetMobileDeviceAccessOverrideCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<GetMobileDeviceAccessOverrideCommandOutput>;
  getMobileDeviceAccessOverride(
    args: GetMobileDeviceAccessOverrideCommandInput,
    cb: (err: any, data?: GetMobileDeviceAccessOverrideCommandOutput) => void
  ): void;
  getMobileDeviceAccessOverride(
    args: GetMobileDeviceAccessOverrideCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: GetMobileDeviceAccessOverrideCommandOutput) => void
  ): void;
  listAccessControlRules(
    args: ListAccessControlRulesCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListAccessControlRulesCommandOutput>;
  listAccessControlRules(
    args: ListAccessControlRulesCommandInput,
    cb: (err: any, data?: ListAccessControlRulesCommandOutput) => void
  ): void;
  listAccessControlRules(
    args: ListAccessControlRulesCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListAccessControlRulesCommandOutput) => void
  ): void;
  listAliases(
    args: ListAliasesCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListAliasesCommandOutput>;
  listAliases(
    args: ListAliasesCommandInput,
    cb: (err: any, data?: ListAliasesCommandOutput) => void
  ): void;
  listAliases(
    args: ListAliasesCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListAliasesCommandOutput) => void
  ): void;
  listAvailabilityConfigurations(
    args: ListAvailabilityConfigurationsCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListAvailabilityConfigurationsCommandOutput>;
  listAvailabilityConfigurations(
    args: ListAvailabilityConfigurationsCommandInput,
    cb: (err: any, data?: ListAvailabilityConfigurationsCommandOutput) => void
  ): void;
  listAvailabilityConfigurations(
    args: ListAvailabilityConfigurationsCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListAvailabilityConfigurationsCommandOutput) => void
  ): void;
  listGroupMembers(
    args: ListGroupMembersCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListGroupMembersCommandOutput>;
  listGroupMembers(
    args: ListGroupMembersCommandInput,
    cb: (err: any, data?: ListGroupMembersCommandOutput) => void
  ): void;
  listGroupMembers(
    args: ListGroupMembersCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListGroupMembersCommandOutput) => void
  ): void;
  listGroups(
    args: ListGroupsCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListGroupsCommandOutput>;
  listGroups(
    args: ListGroupsCommandInput,
    cb: (err: any, data?: ListGroupsCommandOutput) => void
  ): void;
  listGroups(
    args: ListGroupsCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListGroupsCommandOutput) => void
  ): void;
  listGroupsForEntity(
    args: ListGroupsForEntityCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListGroupsForEntityCommandOutput>;
  listGroupsForEntity(
    args: ListGroupsForEntityCommandInput,
    cb: (err: any, data?: ListGroupsForEntityCommandOutput) => void
  ): void;
  listGroupsForEntity(
    args: ListGroupsForEntityCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListGroupsForEntityCommandOutput) => void
  ): void;
  listImpersonationRoles(
    args: ListImpersonationRolesCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListImpersonationRolesCommandOutput>;
  listImpersonationRoles(
    args: ListImpersonationRolesCommandInput,
    cb: (err: any, data?: ListImpersonationRolesCommandOutput) => void
  ): void;
  listImpersonationRoles(
    args: ListImpersonationRolesCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListImpersonationRolesCommandOutput) => void
  ): void;
  listMailboxExportJobs(
    args: ListMailboxExportJobsCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListMailboxExportJobsCommandOutput>;
  listMailboxExportJobs(
    args: ListMailboxExportJobsCommandInput,
    cb: (err: any, data?: ListMailboxExportJobsCommandOutput) => void
  ): void;
  listMailboxExportJobs(
    args: ListMailboxExportJobsCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListMailboxExportJobsCommandOutput) => void
  ): void;
  listMailboxPermissions(
    args: ListMailboxPermissionsCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListMailboxPermissionsCommandOutput>;
  listMailboxPermissions(
    args: ListMailboxPermissionsCommandInput,
    cb: (err: any, data?: ListMailboxPermissionsCommandOutput) => void
  ): void;
  listMailboxPermissions(
    args: ListMailboxPermissionsCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListMailboxPermissionsCommandOutput) => void
  ): void;
  listMailDomains(
    args: ListMailDomainsCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListMailDomainsCommandOutput>;
  listMailDomains(
    args: ListMailDomainsCommandInput,
    cb: (err: any, data?: ListMailDomainsCommandOutput) => void
  ): void;
  listMailDomains(
    args: ListMailDomainsCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListMailDomainsCommandOutput) => void
  ): void;
  listMobileDeviceAccessOverrides(
    args: ListMobileDeviceAccessOverridesCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListMobileDeviceAccessOverridesCommandOutput>;
  listMobileDeviceAccessOverrides(
    args: ListMobileDeviceAccessOverridesCommandInput,
    cb: (err: any, data?: ListMobileDeviceAccessOverridesCommandOutput) => void
  ): void;
  listMobileDeviceAccessOverrides(
    args: ListMobileDeviceAccessOverridesCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListMobileDeviceAccessOverridesCommandOutput) => void
  ): void;
  listMobileDeviceAccessRules(
    args: ListMobileDeviceAccessRulesCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListMobileDeviceAccessRulesCommandOutput>;
  listMobileDeviceAccessRules(
    args: ListMobileDeviceAccessRulesCommandInput,
    cb: (err: any, data?: ListMobileDeviceAccessRulesCommandOutput) => void
  ): void;
  listMobileDeviceAccessRules(
    args: ListMobileDeviceAccessRulesCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListMobileDeviceAccessRulesCommandOutput) => void
  ): void;
  listOrganizations(
    args: ListOrganizationsCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListOrganizationsCommandOutput>;
  listOrganizations(
    args: ListOrganizationsCommandInput,
    cb: (err: any, data?: ListOrganizationsCommandOutput) => void
  ): void;
  listOrganizations(
    args: ListOrganizationsCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListOrganizationsCommandOutput) => void
  ): void;
  listResourceDelegates(
    args: ListResourceDelegatesCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListResourceDelegatesCommandOutput>;
  listResourceDelegates(
    args: ListResourceDelegatesCommandInput,
    cb: (err: any, data?: ListResourceDelegatesCommandOutput) => void
  ): void;
  listResourceDelegates(
    args: ListResourceDelegatesCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListResourceDelegatesCommandOutput) => void
  ): void;
  listResources(
    args: ListResourcesCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListResourcesCommandOutput>;
  listResources(
    args: ListResourcesCommandInput,
    cb: (err: any, data?: ListResourcesCommandOutput) => void
  ): void;
  listResources(
    args: ListResourcesCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListResourcesCommandOutput) => void
  ): void;
  listTagsForResource(
    args: ListTagsForResourceCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListTagsForResourceCommandOutput>;
  listTagsForResource(
    args: ListTagsForResourceCommandInput,
    cb: (err: any, data?: ListTagsForResourceCommandOutput) => void
  ): void;
  listTagsForResource(
    args: ListTagsForResourceCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListTagsForResourceCommandOutput) => void
  ): void;
  listUsers(
    args: ListUsersCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ListUsersCommandOutput>;
  listUsers(
    args: ListUsersCommandInput,
    cb: (err: any, data?: ListUsersCommandOutput) => void
  ): void;
  listUsers(
    args: ListUsersCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ListUsersCommandOutput) => void
  ): void;
  putAccessControlRule(
    args: PutAccessControlRuleCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<PutAccessControlRuleCommandOutput>;
  putAccessControlRule(
    args: PutAccessControlRuleCommandInput,
    cb: (err: any, data?: PutAccessControlRuleCommandOutput) => void
  ): void;
  putAccessControlRule(
    args: PutAccessControlRuleCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: PutAccessControlRuleCommandOutput) => void
  ): void;
  putEmailMonitoringConfiguration(
    args: PutEmailMonitoringConfigurationCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<PutEmailMonitoringConfigurationCommandOutput>;
  putEmailMonitoringConfiguration(
    args: PutEmailMonitoringConfigurationCommandInput,
    cb: (err: any, data?: PutEmailMonitoringConfigurationCommandOutput) => void
  ): void;
  putEmailMonitoringConfiguration(
    args: PutEmailMonitoringConfigurationCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: PutEmailMonitoringConfigurationCommandOutput) => void
  ): void;
  putInboundDmarcSettings(
    args: PutInboundDmarcSettingsCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<PutInboundDmarcSettingsCommandOutput>;
  putInboundDmarcSettings(
    args: PutInboundDmarcSettingsCommandInput,
    cb: (err: any, data?: PutInboundDmarcSettingsCommandOutput) => void
  ): void;
  putInboundDmarcSettings(
    args: PutInboundDmarcSettingsCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: PutInboundDmarcSettingsCommandOutput) => void
  ): void;
  putMailboxPermissions(
    args: PutMailboxPermissionsCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<PutMailboxPermissionsCommandOutput>;
  putMailboxPermissions(
    args: PutMailboxPermissionsCommandInput,
    cb: (err: any, data?: PutMailboxPermissionsCommandOutput) => void
  ): void;
  putMailboxPermissions(
    args: PutMailboxPermissionsCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: PutMailboxPermissionsCommandOutput) => void
  ): void;
  putMobileDeviceAccessOverride(
    args: PutMobileDeviceAccessOverrideCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<PutMobileDeviceAccessOverrideCommandOutput>;
  putMobileDeviceAccessOverride(
    args: PutMobileDeviceAccessOverrideCommandInput,
    cb: (err: any, data?: PutMobileDeviceAccessOverrideCommandOutput) => void
  ): void;
  putMobileDeviceAccessOverride(
    args: PutMobileDeviceAccessOverrideCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: PutMobileDeviceAccessOverrideCommandOutput) => void
  ): void;
  putRetentionPolicy(
    args: PutRetentionPolicyCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<PutRetentionPolicyCommandOutput>;
  putRetentionPolicy(
    args: PutRetentionPolicyCommandInput,
    cb: (err: any, data?: PutRetentionPolicyCommandOutput) => void
  ): void;
  putRetentionPolicy(
    args: PutRetentionPolicyCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: PutRetentionPolicyCommandOutput) => void
  ): void;
  registerMailDomain(
    args: RegisterMailDomainCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<RegisterMailDomainCommandOutput>;
  registerMailDomain(
    args: RegisterMailDomainCommandInput,
    cb: (err: any, data?: RegisterMailDomainCommandOutput) => void
  ): void;
  registerMailDomain(
    args: RegisterMailDomainCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: RegisterMailDomainCommandOutput) => void
  ): void;
  registerToWorkMail(
    args: RegisterToWorkMailCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<RegisterToWorkMailCommandOutput>;
  registerToWorkMail(
    args: RegisterToWorkMailCommandInput,
    cb: (err: any, data?: RegisterToWorkMailCommandOutput) => void
  ): void;
  registerToWorkMail(
    args: RegisterToWorkMailCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: RegisterToWorkMailCommandOutput) => void
  ): void;
  resetPassword(
    args: ResetPasswordCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<ResetPasswordCommandOutput>;
  resetPassword(
    args: ResetPasswordCommandInput,
    cb: (err: any, data?: ResetPasswordCommandOutput) => void
  ): void;
  resetPassword(
    args: ResetPasswordCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: ResetPasswordCommandOutput) => void
  ): void;
  startMailboxExportJob(
    args: StartMailboxExportJobCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<StartMailboxExportJobCommandOutput>;
  startMailboxExportJob(
    args: StartMailboxExportJobCommandInput,
    cb: (err: any, data?: StartMailboxExportJobCommandOutput) => void
  ): void;
  startMailboxExportJob(
    args: StartMailboxExportJobCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: StartMailboxExportJobCommandOutput) => void
  ): void;
  tagResource(
    args: TagResourceCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<TagResourceCommandOutput>;
  tagResource(
    args: TagResourceCommandInput,
    cb: (err: any, data?: TagResourceCommandOutput) => void
  ): void;
  tagResource(
    args: TagResourceCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: TagResourceCommandOutput) => void
  ): void;
  testAvailabilityConfiguration(
    args: TestAvailabilityConfigurationCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<TestAvailabilityConfigurationCommandOutput>;
  testAvailabilityConfiguration(
    args: TestAvailabilityConfigurationCommandInput,
    cb: (err: any, data?: TestAvailabilityConfigurationCommandOutput) => void
  ): void;
  testAvailabilityConfiguration(
    args: TestAvailabilityConfigurationCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: TestAvailabilityConfigurationCommandOutput) => void
  ): void;
  untagResource(
    args: UntagResourceCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<UntagResourceCommandOutput>;
  untagResource(
    args: UntagResourceCommandInput,
    cb: (err: any, data?: UntagResourceCommandOutput) => void
  ): void;
  untagResource(
    args: UntagResourceCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: UntagResourceCommandOutput) => void
  ): void;
  updateAvailabilityConfiguration(
    args: UpdateAvailabilityConfigurationCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<UpdateAvailabilityConfigurationCommandOutput>;
  updateAvailabilityConfiguration(
    args: UpdateAvailabilityConfigurationCommandInput,
    cb: (err: any, data?: UpdateAvailabilityConfigurationCommandOutput) => void
  ): void;
  updateAvailabilityConfiguration(
    args: UpdateAvailabilityConfigurationCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: UpdateAvailabilityConfigurationCommandOutput) => void
  ): void;
  updateDefaultMailDomain(
    args: UpdateDefaultMailDomainCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<UpdateDefaultMailDomainCommandOutput>;
  updateDefaultMailDomain(
    args: UpdateDefaultMailDomainCommandInput,
    cb: (err: any, data?: UpdateDefaultMailDomainCommandOutput) => void
  ): void;
  updateDefaultMailDomain(
    args: UpdateDefaultMailDomainCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: UpdateDefaultMailDomainCommandOutput) => void
  ): void;
  updateGroup(
    args: UpdateGroupCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<UpdateGroupCommandOutput>;
  updateGroup(
    args: UpdateGroupCommandInput,
    cb: (err: any, data?: UpdateGroupCommandOutput) => void
  ): void;
  updateGroup(
    args: UpdateGroupCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: UpdateGroupCommandOutput) => void
  ): void;
  updateImpersonationRole(
    args: UpdateImpersonationRoleCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<UpdateImpersonationRoleCommandOutput>;
  updateImpersonationRole(
    args: UpdateImpersonationRoleCommandInput,
    cb: (err: any, data?: UpdateImpersonationRoleCommandOutput) => void
  ): void;
  updateImpersonationRole(
    args: UpdateImpersonationRoleCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: UpdateImpersonationRoleCommandOutput) => void
  ): void;
  updateMailboxQuota(
    args: UpdateMailboxQuotaCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<UpdateMailboxQuotaCommandOutput>;
  updateMailboxQuota(
    args: UpdateMailboxQuotaCommandInput,
    cb: (err: any, data?: UpdateMailboxQuotaCommandOutput) => void
  ): void;
  updateMailboxQuota(
    args: UpdateMailboxQuotaCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: UpdateMailboxQuotaCommandOutput) => void
  ): void;
  updateMobileDeviceAccessRule(
    args: UpdateMobileDeviceAccessRuleCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<UpdateMobileDeviceAccessRuleCommandOutput>;
  updateMobileDeviceAccessRule(
    args: UpdateMobileDeviceAccessRuleCommandInput,
    cb: (err: any, data?: UpdateMobileDeviceAccessRuleCommandOutput) => void
  ): void;
  updateMobileDeviceAccessRule(
    args: UpdateMobileDeviceAccessRuleCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: UpdateMobileDeviceAccessRuleCommandOutput) => void
  ): void;
  updatePrimaryEmailAddress(
    args: UpdatePrimaryEmailAddressCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<UpdatePrimaryEmailAddressCommandOutput>;
  updatePrimaryEmailAddress(
    args: UpdatePrimaryEmailAddressCommandInput,
    cb: (err: any, data?: UpdatePrimaryEmailAddressCommandOutput) => void
  ): void;
  updatePrimaryEmailAddress(
    args: UpdatePrimaryEmailAddressCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: UpdatePrimaryEmailAddressCommandOutput) => void
  ): void;
  updateResource(
    args: UpdateResourceCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<UpdateResourceCommandOutput>;
  updateResource(
    args: UpdateResourceCommandInput,
    cb: (err: any, data?: UpdateResourceCommandOutput) => void
  ): void;
  updateResource(
    args: UpdateResourceCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: UpdateResourceCommandOutput) => void
  ): void;
  updateUser(
    args: UpdateUserCommandInput,
    options?: __HttpHandlerOptions
  ): Promise<UpdateUserCommandOutput>;
  updateUser(
    args: UpdateUserCommandInput,
    cb: (err: any, data?: UpdateUserCommandOutput) => void
  ): void;
  updateUser(
    args: UpdateUserCommandInput,
    options: __HttpHandlerOptions,
    cb: (err: any, data?: UpdateUserCommandOutput) => void
  ): void;
}
export declare class WorkMail extends WorkMailClient implements WorkMail {}
